;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Runman By: Chdata/Fakescaper
;;For: Tatanga A2MT 2010
;;This sprite will...
;;Eat goal tapes
;;Run to the right really fast
;;Jump off ledges
;;Jump if encountering a wall, along with reversing his direction
;;Run to the right/left depending on the extra bit
;;
;;Extra bit set to 2: Run to the right initially
;;Also when he runs past any goal tapes 
;;by starting from the left of one and passing through it to the the right side,
;;said goal tape shall be eaten. If already to the right of any goal tapes, they'll not appear
;;or if they do they'll disappear as soon as Runman is onscreen to the right of them
;;
;;Extra bit set to 3: Run to the left initially
;;Also when he runs past any goal tapes 
;;by starting from the right of one and passing through it to the the left side,
;;said goal tape shall be eaten. If already to the left of any goal tapes, they'll not appear
;;or if the do they'll disappear as soon as Runman is onscreen to the left of them
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	print "INIT ",pc
	LDA $7FAB10,x
	AND #$04
	LSR
	LSR
	STA $157C,x
	INC $151C,x
	RTL			;Return
	speed:
	db $25,$DB

	print "MAIN ",pc
	PHB : PHK : PLB
	JSR Graphics
	JSR Sprite
	PLB
	RTL

Return:
	RTS
Sprite:
	LDA $14C8,x
	CMP #$08
	BNE Return
	LDA $9D
	BNE Return

	JSR Goal

	JSL $019138

	LDA $1588,x
	ORA $151C,x
	BNE .ON_GROUND_PERHAPS
	JSR DoABarrelRoll

.ON_GROUND_PERHAPS
	LDA $1588,x
	BIT #$03
	BEQ .NotWall
	LDA $151C,x
	BNE .NotWall
	JSR DoABarrelRoll
	LDA $157C,x
	EOR #$01
	STA $157C,x
	JSR SUB_IS_OFF_SCREEN
	BNE .NoNoiseOffscreen
	LDA #$25	;Bang!
	STA $1DFC
.NoNoiseOffscreen

.NotWall
	LDA $1588,x
	AND #$04
	BEQ .Speed
	STZ $151C,x

.Speed
	LDA $1588,x
	AND #$08
	BEQ .NoCeiling
	STZ $AA,x
	STZ $151C,x

.NoCeiling
	PHY
	LDY $157C,x
	LDA speed,y
	PLY
	STA $B6,x
	JSL $01802A	;Give the sprite gravity (update spritepos)
	RTS

DoABarrelRoll:
	LDA #$C4
	STA $AA,x
	LDA #$01
	STA $151C,x
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;GFX Routine				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Tiles:				;
db $00,$02			;
yx:				;
db $35,$75			;Left/Right flips

Graphics:			;
	LDA $14			;
	LSR A			;
	LSR A			;
	LSR A			;
	AND #$01		;
	STA $1602,x		;
	JSR GET_DRAW_INFO	;
	LDA $00			;Draw X position
	STA $0300,y		;
	LDA $01			;Draw Y position
	STA $0301,y		;
	LDA $AA,x		;
	BMI .Up			;
	LDA $1588,x		;
	AND #$04		;
	BEQ .OnAir		;
	PHX			;
	LDA $1602,x		;
	TAX			;
	LDA Tiles,x		;Tile
	STA $0302,y		;
	PLX			;
	BRA .Go			;
.Up	LDA #$06		;
	STA $0302,y		;
	BRA .Go			;
.OnAir	LDA #$04		;
	STA $0302,y		;
.Go	LDA $157C,x		;
	PHX			;
	TAX			;
	LDA yx,x		;YXPPCCCT
	ORA $64			;00110101
	STA $0303,y		;
	PLX			;
	INY #4			;
	LDY #$02		;
	LDA #$00		;
	JSL $01B7B3		;
	RTS			;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Freaking Huge GET_DRAW_INFO		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02
GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x
ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC #$0040
	CMP #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID
	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:  
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS
INVALID:
	PLA
	PLA
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Freaking Huge SUB_OFF_SCREEN		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPR_T12:
db $40,$B0
SPR_T13:
db $01,$FF
SPR_T14:
db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
db $01,$FF,$01,$FF,$01,$FF,$01,$FF
db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SUB_OFF_SCREEN_X0:
	STZ $03
START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS
VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE
SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

Goal:
LDA $7FAB10,x
AND #$04
BNE OtherWay
LDY #11
.loop
LDA $009E,y
CMP #$7B
BNE ++
LDA $14E0,y
XBA
LDA $00E4,y
REP #$20
STA $03
SEP #$20
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CMP $03
SEP #$20
BCC ++
TDC
STA $14C8,y
++
DEY
BPL .loop
RTS

OtherWay:
LDY #11
.loop
LDA $009E,y
CMP #$7B
BNE ++
LDA $14E0,y
XBA
LDA $00E4,y
REP #$20
STA $03
SEP #$20
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CMP $03
SEP #$20
BCS ++
TDC
STA $14C8,y
++
DEY
BPL .loop
RTS